#include "CEnemy.h"


void CEnemy::DecHitPoints()
{
    PHitPoints--;
    PVisibleSwaps = 1;
    if ((PHitPoints < 0) && !PKilled)
    {
        PKilled = true;
        Parent->Add((CGameObject *) new CAnimationObject(IMGExplosion,GetX(),GetY(),90,0.2,20,20,3,20,true,SinCosTable));
    }
}

void CEnemy::Move()
{
    SDL_Surface *Tmp;


    if(!PKilled)
    {
        if(PCanMove)
        {
            if (PVisibleSwaps > 0)
            {
                if(!PVisible)
                {
                    PVisibleSwaps--;
                }
                PVisible = !PVisible;
            }

            switch(PMovementType)
            {
                case 1: //1 direction movement
                    DisplayAngle += PAngleInc;
                    break;
                case 2:
                    if(fix2float<Precission>(PY) > 100)
                    {
                        if(PAngle > 50)
                        {
                            PAngle += PAngleInc * (fix2float<Precission>(PSpeed) / 4);
                            DisplayAngle -= PAngleInc * (fix2float<Precission>(PSpeed) / 4);
                        }
                        if(fix2float<Precission>(PSpeed) < 10)
                            PSpeed = float2fix<Precission>(fix2float<Precission>(PSpeed)+0.2);
                    }

                    break;
                case 3:
                     if(fix2float<Precission>(PY) > 100)
                     {
                        if(PAngle < 130)
                        {
                             PAngle += PAngleInc * (fix2float<Precission>(PSpeed) / 4);
                            DisplayAngle -= PAngleInc * (fix2float<Precission>(PSpeed) / 4);
                        }
                        if(fix2float<Precission>(PSpeed) < 10)
                            PSpeed = float2fix<Precission>(fix2float<Precission>(PSpeed)+0.2);
                     }
                    break;
            }


            UpdateAngle();
            UpdateDisplayAngle();
            PX += VelX;
            PY += VelY;
        }


        if(RealImg)
            Tmp = RealImg;
        else
            Tmp = Img->GetSurfaceAngle(DisplayAngle);


        CollisionRect.x = (fix2float<Precission>(PX) - (Tmp->w/2)) ;
        CollisionRect.y = (fix2float<Precission>(PY) - (Tmp->h/2)) ;
        CollisionRect.w = (Tmp->w);
        CollisionRect.h = (Tmp->h);

        if(( (fix2float<Precission>(PX) ) < 0) || (fix2float<Precission>(PX) >= WINDOW_WIDTH) || ((fix2float<Precission>(PY) ) < 0) || (fix2float<Precission>(PY) >= WINDOW_HEIGHT))
           PKilled = true;
    }

}

