#ifndef CPLAYER_H
#define CPLAYER_H

#include <SDL.h>
#include "CGameObject.h"
#include "CBullet.h"
#include "CSinCosTable.h"
#include "CWorldParts.h"


extern SDL_Surface *IMGBulletPlayer;

class CPlayer : CGameObject
{
    public:
        void MoveLeft(float inc);
        void MoveRight(float inc);
        void MoveUp(float inc);
        void MoveDown(float inc);
        void Shoot();
        CPlayer(SDL_Surface *ImgIn, int Xin, int Yin,int ZOrder, CSinCosTable *SinCosTableIn) : CGameObject(ImgIn, Xin, Yin,0,0, 0,ZOrder , SinCosTableIn)
        {
            PType = 99;
        }

};

#endif
