#include "CAnimationObject.h"

void CAnimationObject::Move()
{
    if(!PKilled)
    {
        PX += VelX;
        PY += VelY;
        DisplayAngle += PAngleInc;
        UpdateDisplayAngle();
        if(RealImg)
        {
            CollisionRect.x = (fix2float<Precission>(PX) - (RealImg->w/2))+3;
            CollisionRect.y = (fix2float<Precission>(PY) - (RealImg->h/2))+3;
            CollisionRect.w = (RealImg->w)-3;
            CollisionRect.h = (RealImg->h)-3;

            if(( (fix2float<Precission>(PX) + (RealImg->w/2)) < 0) || (fix2float<Precission>(PX) - (RealImg->w/2) >= WINDOW_WIDTH) || ((fix2float<Precission>(PY) + (RealImg->h/2)) < 0) || (fix2float<Precission>(PY) - (RealImg->h/2) >= WINDOW_HEIGHT))
                PKilled = true;
        }

        if(PAnimDelayCounter >= PAnimDelay)
        {
            PAnimDelayCounter = 0;
            PFrame++;
            if(PFrame > PNumTiles)
            {
                if(PAutoKill)
                    PKilled = true;
                else
                    PFrame = 0;
            }
        }
        PAnimDelayCounter++;

    }

}

void CAnimationObject::Draw(SDL_Surface *Dest)
{
    if(!PKilled)
    {
        SDL_Rect Dst,Src;
        SDL_Surface *Tmp;
        Tmp = RealImg;

        Dst.x = (int)(fix2float<Precission>(PX)) - (PTileWidth/2);
        Dst.y = (int)(fix2float<Precission>(PY)) - (PTileHeight/2);
        Dst.w = PTileWidth;
        Dst.h = PTileHeight;

        Src.x = PFrame*PTileWidth;
        Src.y = 0;
        Src.w = PTileWidth;
        Src.h = PTileHeight;

        SDL_BlitSurface(Tmp,&Src,Dest,&Dst);
    }
}
