#include "CPlayer.h"


void CPlayer::MoveLeft(float inc)
{
    PX -= float2fix<Precission>(inc);
    if (PX < 0)
        PX = 0;
}

void CPlayer::MoveRight(float inc)
{
    PX += float2fix<Precission>(inc);
    if (PX > float2fix<Precission>(WINDOW_WIDTH-1))
        PX = float2fix<Precission>(WINDOW_WIDTH-1);
}

void CPlayer::MoveUp(float inc)
{
    PY -= float2fix<Precission>(inc);
    if (PY < 0)
        PY = 0;
}


void CPlayer::MoveDown(float inc)
{
    PY += float2fix<Precission>(inc);
    if (PY > float2fix<Precission>(WINDOW_HEIGHT-1))
        PY = float2fix<Precission>(WINDOW_HEIGHT-1);
}

void CPlayer::Shoot()
{
    Parent->Add( (CGameObject*) new CBullet(IMGBulletPlayer, GetX() -5, GetY(), 260,5,7,+10,SinCosTable));
    Parent->Add( (CGameObject*) new CBullet(IMGBulletPlayer, GetX() +5, GetY(), 280,5,7,-10,SinCosTable));
    Parent->Add( (CGameObject*) new CBullet(IMGBulletPlayer, GetX() -2, GetY(), 270,5,7,0,SinCosTable));
    Parent->Add( (CGameObject*) new CBullet(IMGBulletPlayer, GetX() +2, GetY(), 270,5,7,0,SinCosTable));
    Parent->Add( (CGameObject*) new CBullet(IMGBulletPlayer, GetX() -2, GetY(), 270,5,7,-10,SinCosTable));
    Parent->Add( (CGameObject*) new CBullet(IMGBulletPlayer, GetX() +2, GetY(), 270,5,7,+10,SinCosTable));
  //  for (int i = 0; i <= 360;i+=10)
   //     Parent->Add( (CGameObject*) new CBullet(IMGBulletPlayer, 160, 120, i,5,7,SinCosTable));


}




